/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.lang;


import java.net.InetAddress;
import java.net.UnknownHostException;
// γΤ
import java.io.IOException;
import NET.shudo.moba.io.Streamable;
import NET.shudo.moba.io.ObjectWriter;
import NET.shudo.moba.io.ObjectReader;


/**
 * Place Υɥ쥹<BR>
 * Place ΰ֤ IP ɥ쥹ȥݡֹȤɽ롣
 *
 * @see NET.shudo.moba.place.MobaPlace
 */
public class PlaceAddress implements Streamable {
  /**
   * MOBA place Υݡֹ档
   */
  public static int PLACE_PORT = 10000;

  /**
   * CommandServer ԤĥݡֹΡplace ΥݡֹФ뺹ʬ
   */
  public static final int COMMAND_PORT_DIFF = 0;
  /**
   * ClassServer ԤĥݡֹΡplace ΥݡֹФ뺹ʬ
   */
  public static final int CLASS_PORT_DIFF = 1;
  /**
   * ThreadServer ԤĥݡֹΡplace ΥݡֹФ뺹ʬ
   */
  public static final int THREAD_PORT_DIFF = 2;

  private static int controllerPort = PLACE_PORT + 10;	// 10010/tcp
  private static int controllerPortDiff = 10;
  public static void controllerPort(int port) {
    controllerPort = port;
    controllerPortDiff = port - PLACE_PORT;
  }
  public static int controllerPort() {
    return controllerPort;
  }
  public static int controllerPortDiff() {
    return controllerPortDiff;
  }


  private static InetAddress localInetAddress;

  static {
    try {
      localInetAddress = InetAddress.getLocalHost();
    }
    catch (UnknownHostException e) {
      System.err.println("Cannot get local IP address.");
      System.exit(1);
    }
  }


  private InetAddress IPAddr;
  private int portno = PLACE_PORT;


  public PlaceAddress() {}

  public PlaceAddress(InetAddress addr, int portno) {
    this.IPAddr = addr;
    this.portno = portno;
  }
  public PlaceAddress(InetAddress addr) {
    this(addr, PLACE_PORT);
  }

  public PlaceAddress(String host, int portno) throws UnknownHostException {
    this.IPAddr = InetAddress.getByName(host);
    this.portno = portno;
  }
  public PlaceAddress(String host) throws UnknownHostException {
	// accept hostpart:port style
    String hostpart = host;
    int port = PLACE_PORT;

    // hostpart:port б
    int colonIndex = host.lastIndexOf(':');
    if (colonIndex >= 0) {
      hostpart = host.substring(0, colonIndex);
      String portpart = host.substring(colonIndex + 1);
      try { port = Integer.parseInt(portpart); }
      catch (NumberFormatException e) { port = PLACE_PORT; }
    }

    // hostname/ipaddr б
    int slashIndex = host.lastIndexOf('/');
    if (slashIndex >= 0) {
      hostpart = host.substring(0, slashIndex);
    }

    this.IPAddr = InetAddress.getByName(hostpart);
    this.portno = port;
  }


  public int hashCode() {
    return IPAddr.hashCode() + portno * 65535;	// to be improved
  }

  public boolean equals(Object obj) {
    if (obj instanceof PlaceAddress) {
      PlaceAddress addr = (PlaceAddress)obj;
      if (this.IPAddr.equals(addr.IPAddr) && (this.portno == addr.portno))
	return true;
    }
    return false;
  }

  public String toString() {
    return IPAddr.getHostName() + ":" + portno;
  }


  public int port() { return this.portno; }
  public InetAddress inetAddress() { return this.IPAddr; }

  public String hostName() { return this.IPAddr.getHostName(); }
  public String hostAddress() { return this.IPAddr.getHostAddress(); }


  /**
   * 륢ɥ쥹֤
   */
  public static PlaceAddress localAddress() {
    return localAddress;
  }

  private static PlaceAddress localAddress =
			new PlaceAddress(localInetAddress, PLACE_PORT);

  /**
   * Υɥ쥹ʤ鿿֤
   */
  public boolean isLocalAddress() {
    return this.equals(localAddress);
  }


  /**
   * γ᥽åɡ
   */
  public void writeToStream(ObjectWriter out) throws IOException {
    out.writeUTF(this.IPAddr.getHostAddress() + ":" + this.portno);
  }
  /**
   * ᥽åɡ
   */
  public void readFromStream(ObjectReader in) throws IOException {
    String host = in.readUTF();
    int colonIndex = host.lastIndexOf(':');

    String hostpart = host.substring(0, colonIndex);
    this.IPAddr = InetAddress.getByName(hostpart);

    String portpart = host.substring(colonIndex + 1);
    try { this.portno = Integer.parseInt(portpart); }
    catch (NumberFormatException e) { this.portno = PLACE_PORT; }
  }
}
