/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

/* pointer stack for thread.c */

#include <stdio.h>	/* for NULL */

#include "stack.h"


#define STACK_CHUNK_SIZE 10

/*
 * Variables
 */
static void **stack_base = NULL;
static void **stack_ptr = NULL;
static int stack_size = 0;


/*
 * Local Functions
 */
static void **stack_extend();


/*
 * åν
 */
void stack_init() {
  if (!stack_base) {
    stack_size = STACK_CHUNK_SIZE;
    stack_base = (void **)malloc(stack_size * sizeof(void *));
  }
  stack_ptr = stack_base;
}

/*
 * push
 */
void stack_push(void *item) {
  if (stack_ptr >= (stack_base + stack_size)) {
    stack_extend();
  }

  *stack_ptr = item;
  stack_ptr++;
}

/*
 * pop
 */
void *stack_pop() {
  if (stack_ptr <= stack_base) {
    return NULL;
  }

  stack_ptr--;
  return *stack_ptr;
}

/*
 * ɤĴ٤
 */
int stack_is_empty() {
  return (stack_ptr == stack_base);
}

/*
 * åʪο֤
 */
int stack_depth() {
  return (stack_ptr - stack_base);
}


/*
 * Local Functions
 */

static void **stack_extend() {
  int stack_ptr_offset = stack_ptr - stack_base;

  if (!stack_base) {
    stack_init();
  }
  else {
    stack_size += STACK_CHUNK_SIZE;
    stack_base = (void **)realloc(stack_base, stack_size * sizeof(void *));
    stack_ptr = stack_base + stack_ptr_offset;
  }

  return stack_ptr;
}
