  private final Object readBaseTypeArray0(String sig) throws IOException {
    sig = sig.substring(1);

    int len = readInt();
    Object ret = null;

    if (Signature.isByte(sig)) {
      ret = (Object)readByteArray(len);
    }
    else if (Signature.isChar(sig)) {
      ret = (Object)readCharArray(len);
    }
    else if (Signature.isDouble(sig)) {
      ret = (Object)readDoubleArray(len);
    }
    else if (Signature.isFloat(sig)) {
      ret = (Object)readFloatArray(len);
    }
    else if (Signature.isInt(sig)) {
      ret = (Object)readIntArray(len);
    }
    else if (Signature.isLong(sig)) {
      ret = (Object)readLongArray(len);
    }
    else if (Signature.isShort(sig)) {
      ret = (Object)readShortArray(len);
    }
    else if (Signature.isBoolean(sig)) {
      ret = (Object)readBooleanArray(len);
    }
    else {
      // not reached.
      // 顼  not implemented yet.
    }

    return ret;
  }

  private byte[] readByteArray(int len) throws IOException {
    byte[] ret = new byte[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readByte();
    }
    return ret;
  }

  private char[] readCharArray(int len) throws IOException {
    char[] ret = new char[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readChar();
    }
    return ret;
  }

  private double[] readDoubleArray(int len) throws IOException {
    double[] ret = new double[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readDouble();
    }
    return ret;
  }

  private float[] readFloatArray(int len) throws IOException {
    float[] ret = new float[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readFloat();
    }
    return ret;
  }

  private int[] readIntArray(int len) throws IOException {
    int[] ret = new int[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readInt();
    }
    return ret;
  }

  private long[] readLongArray(int len) throws IOException {
    long[] ret = new long[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readLong();
    }
    return ret;
  }

  private short[] readShortArray(int len) throws IOException {
    short[] ret = new short[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readShort();
    }
    return ret;
  }

  private boolean[] readBooleanArray(int len) throws IOException {
    boolean[] ret = new boolean[len];
    for (int i = 0; i < len; i++) {
      ret[i] = readBoolean();
    }
    return ret;
  }
