/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.util;


import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Stack;
import NET.shudo.moba.reflect.*;


/**
 * ֥ȤλȴطéäƽԤ饹
 * ˥ǥХåѡ<BR>
 * γƥ֥ȤФ
 * implements TracerAction ʥ饹롣
 *
 * @see NET.shudo.moba.util.TracerAction
 */
public
class ReferenceTracer {
  private TracerAction action;
  private Object root;

  private boolean done = false;
  private Dictionary objDic;


  public ReferenceTracer(Object root, TracerAction action) {
    this.root = root;
    this.action = action;

    this.objDic = new Hashtable();
  }


  public void reset() {
    this.objDic = new Hashtable();
    this.done = false;
  }


  public void go() {
    if (!done) {
      go(this.root, new Stack());
      this.done = true;
    }
  }

  private void go(Object obj, Stack refStack) {
    if (obj == null)  return;

    if (objDic.get(obj) != null)  return;	// ˽Ѥߤʤ return
    objDic.put(obj, obj);
    // Ūν
    if (!refStack.isEmpty())
      this.action.process(obj, refStack.peek(), refStack);

    MetaClass mc = MetaClass.get(obj);

    if (mc.isBaseTypeArray())  return;		// ܷʤ return;
    else {	// ܷǤϤʤ֥
      refStack.push(obj);

      if (mc.isObjectArray()) {
	Object[] arr = (Object[])obj;
	for (int j = 0; j < arr.length; j++) {
	  go(arr[j], refStack);
	}
      }
      else {	// else ǤϤʤ֥
	for (; mc != null; mc = mc.superClass()) {
		// superclass é
//System.out.println("[class: " + mc.getName() + "]");
	  for (int i = 0; i < mc.fieldCount(); i++) {	// field é
	    MetaField field = null;
	    try {
	      field = mc.field(i);
	    }
	    catch (FieldNotFoundException e) {
	      // not reached.
	      e.printStackTrace();  System.exit(1);
	    }
//System.out.println("[field: " + field.name() + "]");

	    if (field.isObject()) {
	      Object tgt = field.getObjectValue(obj);
	      go(tgt, refStack);		// recursive call
	    }
	  }	// field é
	}	// superclass é
      }	// ǤϤʤ֥

      refStack.pop();
    }	// ܷǤϤʤ֥
  }
}
